# JavaScriptGenerator class

Generates JavaScript and TypeScript.

```csharp
public sealed class JavaScriptGenerator : CodeGenerator
```

## Public Members

| name | description |
| --- | --- |
| [JavaScriptGenerator](JavaScriptGenerator/JavaScriptGenerator.md)() | The default constructor. |
| [DisableESLint](JavaScriptGenerator/DisableESLint.md) { get; set; } | True to disable ESLint via code comment. |
| [Express](JavaScriptGenerator/Express.md) { get; set; } | True to generate Express service. |
| [Fastify](JavaScriptGenerator/Fastify.md) { get; set; } | True to generate Fastify plugin. |
| [FileNameSuffix](JavaScriptGenerator/FileNameSuffix.md) { get; set; } | Suffix to append to generated file names before the extension. |
| [ModuleName](JavaScriptGenerator/ModuleName.md) { get; set; } | The name of the module (optional). |
| override [SupportsSingleOutput](JavaScriptGenerator/SupportsSingleOutput.md) { get; } | Supports writing output to a single file. |
| [TypeScript](JavaScriptGenerator/TypeScript.md) { get; set; } | True to generate TypeScript. |
| override [ApplySettings](JavaScriptGenerator/ApplySettings.md)(…) | Applies generator-specific settings. |
| override [GenerateOutput](JavaScriptGenerator/GenerateOutput.md)(…) | Generates the JavaScript/TypeScript output. |
| static [GenerateCSharp](JavaScriptGenerator/GenerateCSharp.md)(…) | Generates JavaScript/TypeScript. |

## See Also

* namespace [Facility.CodeGen.JavaScript](../Facility.CodeGen.JavaScript.md)
* [JavaScriptGenerator.cs](https://github.com/FacilityApi/FacilityJavaScript/tree/master/src/Facility.CodeGen.JavaScript/JavaScriptGenerator.cs)

<!-- DO NOT EDIT: generated by xmldocmd for Facility.CodeGen.JavaScript.dll -->
