# JavaScriptGeneratorSettings class

Settings for generating JavaScript and TypeScript.

```csharp
public sealed class JavaScriptGeneratorSettings : FileGeneratorSettings
```

## Public Members

| name | description |
| --- | --- |
| [JavaScriptGeneratorSettings](JavaScriptGeneratorSettings/JavaScriptGeneratorSettings.md)() | The default constructor. |
| [DisableESLint](JavaScriptGeneratorSettings/DisableESLint.md) { get; set; } | True to disable ESLint via code comment. |
| [Express](JavaScriptGeneratorSettings/Express.md) { get; set; } | True to generate Express service. |
| [Fastify](JavaScriptGeneratorSettings/Fastify.md) { get; set; } | True to generate Fastify plugin. |
| [FileNameSuffix](JavaScriptGeneratorSettings/FileNameSuffix.md) { get; set; } | Suffix to append to generated file names before the extension. |
| [ModuleName](JavaScriptGeneratorSettings/ModuleName.md) { get; set; } | The name of the module (optional). |
| [TypeScript](JavaScriptGeneratorSettings/TypeScript.md) { get; set; } | True to generate TypeScript. |

## See Also

* namespace [Facility.CodeGen.JavaScript](../Facility.CodeGen.JavaScript.md)
* [JavaScriptGeneratorSettings.cs](https://github.com/FacilityApi/FacilityJavaScript/tree/master/src/Facility.CodeGen.JavaScript/JavaScriptGeneratorSettings.cs)

<!-- DO NOT EDIT: generated by xmldocmd for Facility.CodeGen.JavaScript.dll -->
